SystemOrganization addCategory: #'IRDA2013-sorting2-SorterClasses'!

Object subclass: #S2AbstractFocusedIndicesEvaluator
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractFocusedIndicesEvaluator class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:38:38.727'!
newWithList: aList
|me|
	me := self new.
	me list: aList. 
	^me.! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'subclass responsibility' stamp: 'AT 6/25/2013 17:20:52.3'!
evaluateFocusedElements
	(self shouldUpdateElements) ifTrue: [self updateElements]! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:37:08.98'!
list

	^ list! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:37:08.996'!
list: anObject

	list := anObject! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'subclass responsibility' stamp: 'AT 6/25/2013 17:12:39.512'!
shouldUpdateElements
	^true.! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'subclass responsibility' stamp: 'AT 6/25/2013 15:31:55.329'!
updateElements! !

S2AbstractFocusedIndicesEvaluator subclass: #S2BubblesortFocusedIndicesEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 14:54:46.689'!
shouldUpdateElements
"swap condition"
	^self list firstFocusedElement > self list secondFocusedElement! !

!S2BubblesortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 14:54:42.394'!
updateElements
"swap"
	^self list swapFocusedElements.! !

S2AbstractFocusedIndicesEvaluator subclass: #S2MergesortFocusedIndicesEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2MergesortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:11:36.207'!
updateElements
	(self list firstFocusedElement <= self list secondFocusedElement)
		ifTrue: [self list addElementIndexToTmpList: self list firstFocusedIndex]
		ifFalse: [self list addElementIndexToTmpList: self list secondFocusedIndex].! !

S2AbstractFocusedIndicesEvaluator subclass: #S2QuicksortFocusedIndicesEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 15:41:59.269'!
shouldUpdateElements
	^(self list firstFocusedElement > self list pivotElement) and: (self list secondFocusedElement < self list pivotElement).! !

!S2QuicksortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 7/1/2013 15:34:29.216'!
updateElements
	^self list swapFocusedElements.! !

Object subclass: #S2AbstractFocusedIndicesFinder
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractFocusedIndicesFinder class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:38:34.39'!
newWithList: aList
|me|
	me := self new.
	me list: aList. 
	^me.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:36:44.487'!
list

	^ list! !

!S2AbstractFocusedIndicesFinder methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:36:44.508'!
list: anObject

	list := anObject! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/25/2013 15:32:21.376'!
updateFocusedIndices! !

S2AbstractFocusedIndicesFinder subclass: #S2BubblesortFocusedIndicesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:28:26.971'!
updateFocusedIndices
"after two elements have been compared and probably swapped"
	self list updateFirstFocusedIndex: self list firstFocusedIndex + 1.
	self list updateSecondFocusedIndex: self list secondFocusedIndex + 1.! !

S2AbstractFocusedIndicesFinder subclass: #S2MergesortFocusedIndicesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2MergesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 09:10:01.356'!
updateFirstFocusedIndex
	self list updateFirstFocusedIndex: (self list partitionIndices at: (self list activePartitions first)) first.! !

!S2MergesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:27:48.739'!
updateFocusedIndices
"sets the focused index to the first indices stored in the active partitions."
	self list updateFirstFocusedIndex: (self list partitionIndices at: (self list activePartitions first)) first.
	self list updateSecondFocusedIndex: (self list partitionIndices at: (self list activePartitions second)) first.! !

!S2MergesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 09:10:12.579'!
updateSecondFocusedIndex
	self list updateSecondFocusedIndex: (self list partitionIndices at: (self list activePartitions second)) first.! !

S2AbstractFocusedIndicesFinder subclass: #S2QuicksortFocusedIndicesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:28:01.008'!
updateFirstFocusedIndex
	self list updateFirstFocusedIndex: self list firstFocusedIndex + 1.! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 16:10:53.003'!
updateFocusedIndices
"Keep on searching a leftern element larger than the pivot and a rightern one smaller than the pivot"
	(self list firstFocusedElement <= self list pivotElement)
		ifTrue: [self updateFirstFocusedIndex]
		ifFalse: [(self list secondFocusedElement >= self list pivotElement)
			ifTrue: [self updateSecondFocusedIndex]
			ifFalse: [self error:'I got stuck']].! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:28:08.466'!
updateSecondFocusedIndex
	self list updateSecondFocusedIndex: self list secondFocusedIndex - 1.! !

Object subclass: #S2AbstractIterator
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractIterator class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:38:28.133'!
newWithList: aList
|me|
	me := self new.
	me list: aList. 
	^me.! !

!S2AbstractIterator methodsFor: 'subclass responsibility' stamp: 'AT 6/25/2013 13:44:18.985'!
keepFocusing
	^self subclassResponsibility.! !

!S2AbstractIterator methodsFor: 'subclass responsibility' stamp: 'AT 6/25/2013 13:44:52.584'!
keepSublistIterating
	^self subclassResponsibility.! !

!S2AbstractIterator methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:36:20.075'!
list

	^ list! !

!S2AbstractIterator methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:36:20.094'!
list: anObject

	list := anObject! !

S2AbstractIterator subclass: #S2BubblesortIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 14:53:41.084'!
keepFocusing
"inner while loop condition"
	^self list secondFocusedIndex < self list firstSortedIndex.! !

!S2BubblesortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 14:53:49.934'!
keepSublistIterating
"outer while loop condition"
	^self list firstSortedIndex > 1! !

S2AbstractIterator subclass: #S2MergesortIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2MergesortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 16:17:51.904'!
keepFocusing
"As long as the two active partitions are not empty, keep on going."
	^(self list activePartitions select: [:ea | (self list partitions at: ea) isEmpty] ) isEmpty.! !

!S2MergesortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 16:18:23.342'!
keepSublistIterating
	^list partitionIndices size > 1! !

S2AbstractIterator subclass: #S2QuicksortIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

S2QuicksortIterator subclass: #S2OOPQuicksortIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2OOPQuicksortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 18:10:30.151'!
keepSublistIterating
	^(self list partitionIndices select: [:ea | ea size > 1]) isEmpty not.! !

!S2QuicksortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 15:27:03.806'!
keepFocusing
	^self list firstFocusedIndex < self list secondFocusedIndex.! !

!S2QuicksortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 15:43:03.303'!
keepSublistIterating
	^self list sortedIndices size < self list elements size.! !

Object subclass: #S2AbstractSorter
	instanceVariableNames: 'list iterator listPartFinder listPartSorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:28:33.137'!
newWithElements: aCollection
|me|
	me := self new.
	me setupWithList: (S2List newWithElements: (aCollection asOrderedCollection)).
	^me.! !

!S2AbstractSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:28:38.321'!
newWithList: anS2List
|me|
	me := self new.
	me setupWithList: anS2List.
	^me.! !

!S2AbstractSorter methodsFor: 'subclass responisbility' stamp: 'AT 7/1/2013 14:24:21.238'!
afterSorting
	self list	updateSorted: true.! !

!S2AbstractSorter methodsFor: 'subclass responisbility' stamp: 'db 6/26/2013 01:25:10.006'!
beforeSorting
	"returns false if there is no need to sort the list."
 	^true! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.445'!
iterator

	^ iterator! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.458'!
iterator: anObject

	iterator := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.416'!
list

	^ list! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/17/2013 17:05:55.984'!
list: anObject
	list := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.476'!
listPartFinder

	^ listPartFinder! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.489'!
listPartFinder: anObject

	listPartFinder := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.5'!
listPartSorter

	^ listPartSorter! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.511'!
listPartSorter: anObject

	listPartSorter := anObject! !

!S2AbstractSorter methodsFor: 'sorting' stamp: 'AT 6/27/2013 09:28:32.311'!
setupListProperties! !

!S2AbstractSorter methodsFor: 'setup' stamp: 'AT 6/17/2013 17:26:58.32'!
setupWithList: anS2List
	^self subclassResponsibility.! !

!S2AbstractSorter methodsFor: 'sorting' stamp: 'AT 6/27/2013 17:42:28.137'!
sort
	Transcript clear.
	Transcript show: self list elements asString, String cr.
	(self beforeSorting) ifFalse: [^self list elements].
	self setupListProperties.
	[ self iterator keepSublistIterating] whileTrue:
		[self listPartFinder findSublist.
		self listPartSorter sortSublist.].
	self afterSorting.! !

S2AbstractSorter subclass: #S2BubbleSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubbleSorter commentStamp: 'db 5/28/2013 22:10:24.268' prior: 0!
TODO subclassing morph only for stepping here..move this logic to challenge/appmorph?!

!S2BubbleSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 09:30:30.391'!
setupListProperties
	self list leftBoundIndex ifNil: [self list updateLeftBoundaryIndex: 1].
	self list rightBoundIndex ifNil: [self list updateRightBoundaryIndex: (self list firstSortedIndex - 1)].! !

!S2BubbleSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 11:44:32.361'!
setupWithList: anS2List
	self list: anS2List.
	self iterator: (S2BubblesortIterator newWithList: anS2List).
	self listPartFinder: (S2BubblesortSublistFinder newWithList: anS2List).
	self listPartSorter: (S2BubblesortSublistSorter newWithList: anS2List).! !

S2AbstractSorter subclass: #S2MergeSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2MergeSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:07:26.25'!
beforeSorting
	(self list elements size < 2) ifTrue: [^false].
	self list splitAll.
	self list activatePartition: 1.
	self list activatePartition: 2.
	^true.! !

!S2MergeSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 09:33:06.241'!
setupListProperties
"assuming that active partition setting is one step for both paritions here"
	(self list activePartitions size = 0) 
		ifTrue: [ self list activatePartition: 1.
			self list activatePartition: 2. ]! !

!S2MergeSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 15:12:05.19'!
setupWithList: anS2List
	self list: anS2List.
	self iterator: (S2MergesortIterator newWithList: self list).
	self listPartFinder: (S2MergesortSublistFinder newWithList: self list).
	self listPartSorter: (S2MergesortSublistSorter newWithList: self list).! !

S2AbstractSorter subclass: #S2QuickSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

S2QuickSorter subclass: #S2OOPQuickSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2OOPQuickSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 17:54:55.069'!
setupListProperties
	(self list activePartitions isNil or: self list partitionIndices isNil) ifTrue: [ 
		self list setupMultiListInterface.
		self list activatePartition: 1].! !

!S2OOPQuickSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 18:09:28.694'!
setupWithList: anS2List
	self list: anS2List.
	self iterator: (S2OOPQuicksortIterator newWithList: self list).
	self listPartFinder: (S2OOPQuicksortSublistFinder newWithList: self list).
	self listPartSorter: (S2OOPQuicksortSublistSorter newWithList: self list).! !

!S2QuickSorter methodsFor: 'initializing' stamp: 'AT 6/27/2013 09:37:29.986'!
beforeSorting
	^self list elements size > 1.! !

!S2QuickSorter methodsFor: 'initializing' stamp: 'AT 7/1/2013 14:27:36.136'!
setupListProperties
	"self list leftBoundIndex ifNil: [self list updateLeftBoundaryIndex: 1].
	self list rightBoundIndex ifNil: [self list updateRightBoundaryIndex: self list elements size]."! !

!S2QuickSorter methodsFor: 'initializing' stamp: 'AT 6/24/2013 11:43:26.256'!
setupWithList: anS2List
	self list: anS2List.
	self iterator: (S2QuicksortIterator newWithList: self list).
	self listPartFinder: (S2QuicksortSublistFinder newWithList: self list).
	self listPartSorter: (S2QuicksortSublistSorter newWithList: self list).! !

Object subclass: #S2AbstractSublistFinder
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractSublistFinder class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:38:22.505'!
newWithList: aList
|me|
	me := self new.
	me list: aList. 
	^me.! !

!S2AbstractSublistFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/25/2013 15:33:12.639'!
findSublist! !

!S2AbstractSublistFinder methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:35:26.647'!
list

	^ list! !

!S2AbstractSublistFinder methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:35:26.665'!
list: anObject

	list := anObject! !

S2AbstractSublistFinder subclass: #S2BubblesortSublistFinder
	instanceVariableNames: 'left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortSublistFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:25:11.656'!
findSublist
"Convenience method here, not actually needed for bublesort."
	self list updateLeftBoundaryIndex: 1.
	self list updateRightBoundaryIndex: (self list firstSortedIndex - 1).! !

S2AbstractSublistFinder subclass: #S2MergesortSublistFinder
	instanceVariableNames: 'left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2MergesortSublistFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 17:49:40.252'!
findSublist
"activates the correct partitions"
| mappedSizes firstSmallest |
	mappedSizes := (self list partitionIndices) collect: [:ea | ea size].
	firstSmallest := mappedSizes indexOf: (mappedSizes sorted first).
	(firstSmallest = mappedSizes size)
		ifTrue: [ | secondSmallest |
			secondSmallest := mappedSizes indexOf: (mappedSizes asSet asOrderedCollection second).
			self list activatePartition: secondSmallest.
			self list activatePartition: (secondSmallest + 1) ] 
		ifFalse: [ self list activatePartition: firstSmallest.
			self list activatePartition: (firstSmallest + 1) ].! !

S2AbstractSublistFinder subclass: #S2QuicksortSublistFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

S2QuicksortSublistFinder subclass: #S2OOPQuicksortSublistFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2OOPQuicksortSublistFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 18:07:00.769'!
findSublist
	self list activatePartition: (self list partitionIndices indexOf: (self list partitionIndices select: [:ea | ea size > 1]) first).! !

!S2QuicksortSublistFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:26:38.134'!
findSublist
"sets the left and right bound of the currently considered sublist"
| sequence unsorted |
	unsorted := ((1 to: self list elements size) copyWithoutAll: self list sortedIndices) asOrderedCollection.
	sequence := #() asOrderedCollection.
	sequence add: (unsorted remove: (unsorted first)).
	unsorted do: [:ea |
		((sequence last + 1) = ea) ifTrue: [sequence add: ea]].
	self list updateLeftBoundaryIndex: sequence first.
	self list updateRightBoundaryIndex: sequence last.
! !

Object subclass: #S2AbstractSublistSorter
	instanceVariableNames: 'list focusedIndexFinder focusedIndexEvaluator iterator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractSublistSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:21:07.698'!
newWithList: anS2List
|me|
	me := self new.
	me setupWithList: anS2List.
	^me.! !

!S2AbstractSublistSorter methodsFor: 'subclass responsibility' stamp: 'AT 6/25/2013 15:33:49.766'!
afterSortSublist! !

!S2AbstractSublistSorter methodsFor: 'subclass responsibility' stamp: 'AT 6/25/2013 15:33:57.558'!
beforeSortSublist! !

!S2AbstractSublistSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.342'!
focusedIndexEvaluator

	^ focusedIndexEvaluator! !

!S2AbstractSublistSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.353'!
focusedIndexEvaluator: anObject

	focusedIndexEvaluator := anObject! !

!S2AbstractSublistSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.312'!
focusedIndexFinder

	^ focusedIndexFinder! !

!S2AbstractSublistSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.328'!
focusedIndexFinder: anObject

	focusedIndexFinder := anObject! !

!S2AbstractSublistSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.371'!
iterator

	^ iterator! !

!S2AbstractSublistSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.383'!
iterator: anObject

	iterator := anObject! !

!S2AbstractSublistSorter methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:35:55.005'!
list

	^ list! !

!S2AbstractSublistSorter methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:35:55.022'!
list: anObject

	list := anObject! !

!S2AbstractSublistSorter methodsFor: 'sorting' stamp: 'AT 6/27/2013 09:07:10.497'!
resetListProperties! !

!S2AbstractSublistSorter methodsFor: 'sorting' stamp: 'AT 6/27/2013 09:07:03.776'!
setupListProperties! !

!S2AbstractSublistSorter methodsFor: 'sorting' stamp: 'AT 6/17/2013 17:21:18.892'!
setupWithList: list
	^self subclassResponsibility.! !

!S2AbstractSublistSorter methodsFor: 'sorting' stamp: 'AT 7/1/2013 14:16:49.963'!
sortSublist
	self beforeSortSublist.
	[ self iterator keepFocusing] whileTrue:
		[ self focusedIndexEvaluator evaluateFocusedElements.
		(self iterator keepFocusing) ifTrue: [self focusedIndexFinder updateFocusedIndices]].
	self afterSortSublist.
	self resetListProperties.! !

S2AbstractSublistSorter subclass: #S2BubblesortSublistSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 14:51:32.199'!
afterSortSublist
"Marks the last sublist element as sorted."
	(self list firstSortedIndex isNil)
		ifTrue: [self list firstSortedIndex: self list elements size.] 
		ifFalse: [self list firstSortedIndex: self list firstSortedIndex - 1]
	! !

!S2BubblesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:34:40.659'!
beforeSortSublist
"Sets the per round initial first and second focused index."
	self list updateFirstFocusedIndex: 1.
	self list updateSecondFocusedIndex: 2.
	! !

!S2BubblesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 09:00:53.668'!
resetListProperties
	self list updateLeftBoundaryIndex: nil;
				updateRightBoundaryIndex: nil;
				updateFirstFocusedIndex: nil;
				updateSecondFocusedIndex: nil.! !

!S2BubblesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 09:08:23.069'!
setupListProperties
"Sets the per round initial first and second focused index."
	self list firstFocusedIndex ifNil: [self list updateFirstFocusedIndex: 1].
	self list secondFocusedIndex ifNil: [self list updateSecondFocusedIndex: 2].
	! !

!S2BubblesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:19:35.109'!
setupWithList: list
	self list: list.
	self focusedIndexFinder: (S2BubblesortFocusedIndicesFinder newWithList: list).
	self focusedIndexEvaluator: (S2BubblesortFocusedIndicesEvaluator newWithList: list).
	self iterator: (S2BubblesortIterator newWithList: list).! !

S2AbstractSublistSorter subclass: #S2MergesortSublistSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2MergesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 16:38:53.179'!
afterSortSublist
	self appendListRestsToTmpList.
	self list mergeBackTmpList.
	self deactivatePartitions.! !

!S2MergesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:16:21.384'!
appendListRestsToTmpList
	self list activePartitions do: [:ea | 
		(self list partitionIndices at: ea) do: [:idx |
			self list addElementIndexToTmpList: idx]].! !

!S2MergesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 16:58:25.536'!
beforeSortSublist
	self focusedIndexFinder updateFocusedIndices.! !

!S2MergesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 17:05:22.245'!
deactivatePartitions
	[self list activePartitions size > 0] whileTrue: [self list deactivatePartition: self list activePartitions first.]! !

!S2MergesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 09:04:30.322'!
resetListProperties
	self deactivatePartitions.
	self list updateFirstFocusedIndex: nil.
	self list updateSecondFocusedIndex: nil.! !

!S2MergesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 09:22:15.691'!
setupListProperties
	self list firstFocusedIndex ifNil: [self focusedIndexFinder updateFirstFocusedIndex].
	self list secondFocusedIndex ifNil: [self focusedIndexFinder updateSecondFocusedIndex].! !

!S2MergesortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 15:13:46.613'!
setupWithList: list
	self list: list.
	self focusedIndexFinder: (S2MergesortFocusedIndicesFinder newWithList: self list).
	self focusedIndexEvaluator: (S2MergesortFocusedIndicesEvaluator newWithList: self list).
	self iterator: (S2MergesortIterator newWithList: self list).! !

S2AbstractSublistSorter subclass: #S2QuicksortSublistSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

S2QuicksortSublistSorter subclass: #S2OOPQuicksortSublistSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2OOPQuicksortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 18:12:30.9'!
afterSortSublist
	self updatePivotPosition.
	self updateSortedIndices.
	(self list pivotIndex > 1) ifTrue: [
	self list splitAfter: self list pivotIndex-1.].
	(self list pivotIndex < self list elements size) ifTrue: 
	[self list splitAfter: self list pivotIndex].! !

!S2OOPQuicksortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 17:34:12.671'!
beforeSortSublist
| active |
	active := self list partitionIndices at: (self list activePartitions first).
	self list updatePivotIndex: active last.
	self list updateFirstFocusedIndex: active first.
	self list updateSecondFocusedIndex: active last - 1.! !

!S2OOPQuicksortSublistSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 18:02:13.21'!
resetListProperties
	self list updateActivePartitions: #() asOrderedCollection.
	self list updatePivotIndex: nil.
	self list updateFirstFocusedIndex: nil.
	self list updateSecondFocusedIndex: nil.! !

!S2QuicksortSublistSorter methodsFor: 'reset' stamp: 'AT 6/27/2013 17:42:59.694'!
afterSortSublist
	self updatePivotPosition.
	self updateSortedIndices.! !

!S2QuicksortSublistSorter methodsFor: 'setup' stamp: 'AT 7/1/2013 12:28:38.955'!
beforeSortSublist
	self list updatePivotIndex: self list rightBoundIndex.
	self list updateFirstFocusedIndex: self list leftBoundIndex.
	"Handle sublistsof length 1"
	(self list rightBoundIndex > self list leftBoundIndex) 
		ifTrue: [self list updateSecondFocusedIndex: self list rightBoundIndex - 1]
		ifFalse: [self list updateSecondFocusedIndex: self list rightBoundIndex].	! !

!S2QuicksortSublistSorter methodsFor: 'reset' stamp: 'AT 6/27/2013 17:34:35.886'!
resetListProperties
	self list updateLeftBoundaryIndex: nil;
				updateRightBoundaryIndex: nil;
				updateFirstFocusedIndex: nil;
				updateSecondFocusedIndex: nil;
				updatePivotIndex: nil.! !

!S2QuicksortSublistSorter methodsFor: 'initialize' stamp: 'AT 6/17/2013 17:20:37.678'!
setupWithList: list
	self list: list.
	self focusedIndexFinder: (S2QuicksortFocusedIndicesFinder newWithList: self list).
	self focusedIndexEvaluator: (S2QuicksortFocusedIndicesEvaluator newWithList: self list).
	self iterator: (S2QuicksortIterator newWithList: self list).! !

!S2QuicksortSublistSorter methodsFor: 'updates' stamp: 'AT 7/1/2013 15:10:50.746'!
updatePivotPosition
	self list pivotElement > self list firstFocusedElement
		ifTrue: [self list insertPivotAt: (self list firstFocusedIndex + 1)]
		ifFalse: [self list insertPivotAt: (self list firstFocusedIndex)].! !

!S2QuicksortSublistSorter methodsFor: 'updates' stamp: 'AT 6/17/2013 18:43:31.46'!
updateSortedIndices
	self list addIndexAsSorted: self list pivotIndex.! !

Object subclass: #S2List
	instanceVariableNames: 'sortedIndices elements leftBoundIndex rightBoundIndex firstFocusedIndex secondFocusedIndex pivotIndex partitionIndices activePartitions tmpList isSorted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2List class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:02:09.927'!
newWithElements: aCollection
|me|
	me := self new.
	me setupList: (aCollection asOrderedCollection).
	^me.! !

!S2List methodsFor: 'updating-multilist' stamp: 'db 6/27/2013 20:33:36.362'!
activatePartition: idx
|active|
	idx ifNotNil: [
		Transcript show:'activating partition at: ',idx,String cr.
		(self activePartitions includes: idx) ifFalse: [
			active := self activePartitions copy.
			active add: idx.
			self updateActivePartitions: active]].
	self signalStateChange.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/25/2013 10:53:52.787'!
activePartitions
"Since a list can be split into sublists, some algorithms work on exactly two sublists at a time."
	^ activePartitions! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/25/2013 17:07:31.372'!
activePartitions: anObject
	activePartitions := anObject! !

!S2List methodsFor: 'updating-multilist' stamp: 'db 6/27/2013 20:33:42.434'!
addElementIndexToTmpList: idx
	| oldP el |
	Transcript show: 'Adding element ', (self elements at: idx) ,' at ',idx, ' to tmpList ', self tmpList asString, String cr.
	oldP := (self partitionIndices select: [:ea | ea includes: idx]) first.
	oldP remove: idx.
	el := self elements at: idx.
	self elements at: idx put: nil.
	self tmpList add: el.
	self signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/30/2013 19:49:45.841'!
addIndexAsSorted: idx
	Transcript show:'new sorted index: ',idx asString, String cr.
	self sortedIndices add: idx.
	Transcript show: 'sorted indices: ',self sortedIndices, String cr.
	self signalStateChange.! !

!S2List methodsFor: 'stringification' stamp: 'AT 6/25/2013 10:45:15.581'!
asString
| string tmpList partitions |
	string := ''.
	tmpList := self tmpList.
	partitions := self partitions.
	(partitions isNil not and: [partitions size > 0]) 
		ifTrue: [ |partitionsString|
			partitionsString := partitions collect: [:ea | ea asArray].
			string := string, 'sublists: ', partitionsString]
		ifFalse: [string := string, 'elements: ', self elements asString.].
	(tmpList isNil not and: [tmpList size > 0]) ifTrue: [
		string := string, String cr.
		string := string, 'tmpList: '.
		string := string, tmpList asString].
	^string! !

!S2List methodsFor: 'updating-multilist' stamp: 'db 6/27/2013 20:33:50.092'!
deactivatePartition: idx
|active|
	idx ifNotNil: [
		Transcript show:'deactivating partition at: ',idx,String cr.
		(self activePartitions includes: idx) ifTrue: [
			active := self activePartitions copy.
			active remove: idx.
			self updateActivePartitions: active]].
	self signalStateChange.! !

!S2List methodsFor: 'debugging' stamp: 'db 6/28/2013 16:14:20.65'!
debugString
	| string |
	string := self elements asArray asString,		
		' l:', self leftBoundIndex,
		' r:', self rightBoundIndex,
		' p:', self pivotIndex, 
		' f1:', self firstFocusedIndex, ' f2:', self secondFocusedIndex,
		' sorted:', self sortedIndices asArray asString,
		' pIdxs:', self partitionIndices,
		' parts:', self partitions,
		' tmp:', self tmpList.
	^string.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:01:33.217'!
elements

	^ elements! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:40.812'!
elements: anObject

	elements := anObject.! !

!S2List methodsFor: 'comparing' stamp: 'AT 7/2/2013 23:16:06.385'!
equals: aList
| f1 f2 |
f1 := self firstFocusedIndex asOrderedCollection.
f1 add: self secondFocusedIndex.
(f1 includes: nil) ifTrue: [f1 remove: nil.].
f2 := aList firstFocusedIndex asOrderedCollection.
f2 add: aList secondFocusedIndex.
(f2 includes: nil) ifTrue: [f2 remove: nil.].
	^(self sortedIndices = aList sortedIndices)
	and: ((self elements = aList elements) 
	and: (self leftBoundIndex = aList leftBoundIndex) 
	and: (self rightBoundIndex = aList rightBoundIndex))
	and: ((f1 asSet = f2 asSet)
	and: (self pivotIndex = aList pivotIndex)
	and: (self partitionIndices = aList partitionIndices))
	and: ((self activePartitions = aList activePartitions)
	and: (self tmpList = aList tmpList)
	and: (self isSorted = aList isSorted))! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 10:14:22.772'!
firstFocusedElement
	(self firstFocusedIndex isNil or: [self firstFocusedIndex > self elements size]) ifTrue: [^nil].
	^ self elements at: self firstFocusedIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.685'!
firstFocusedIndex

	^ firstFocusedIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.759'!
firstFocusedIndex: anObject

	firstFocusedIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/25/2013 14:41:34.365'!
firstSortedIndex
	(self sortedIndices size > 0) 
		ifTrue: [^self sortedIndices first]
		ifFalse: [^self elements size + 1]! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/25/2013 13:57:44.816'!
firstSortedIndex: idx
	self sortedIndices: (idx to: self elements size) asOrderedCollection.! !

!S2List methodsFor: 'initialization' stamp: 'db 6/27/2013 01:19:50.352'!
initialize
	super initialize.
	self elements: #() asOrderedCollection;
		sortedIndices: #() asSortedCollection;
		isSorted: false.! !

!S2List methodsFor: 'updating' stamp: 'AT 7/3/2013 21:42:52.752'!
insertPivotAt: p
|templeft tempmiddle tempright copy|
	Transcript show:'Moving Pivot from ',self pivotIndex asString, ' to ', p asString, String cr.
	copy := self elements copy.
	(self pivotIndex = p) ifFalse: [
		(self pivotIndex > p) ifTrue: [templeft := self elements copyFrom: 1 to: p-1.
			tempmiddle := self elements copyFrom: p to: self pivotIndex-1.
			tempright := self elements copyFrom: (self pivotIndex + 1) to: self elements size.
			self elements: templeft, self pivotElement asOrderedCollection,tempmiddle, tempright.].
		(self pivotIndex < p) ifTrue: [templeft := self elements copyFrom: 1 to: self pivotIndex -1.
			tempmiddle := self elements copyFrom: (self pivotIndex + 1) to: p-1.
			tempright := self elements copyFrom: p to: self elements size.
			self elements: templeft,tempmiddle,self pivotElement asOrderedCollection, tempright.].
		"suppress a signal here"
		self pivotIndex: p.
		(self firstFocusedIndex) ifNotNil: [(self firstFocusedIndex >= p) ifTrue: [self firstFocusedIndex: self firstFocusedIndex + 1]].
		(self secondFocusedIndex) ifNotNil: [(self secondFocusedIndex >= p) ifTrue: [self secondFocusedIndex: self secondFocusedIndex + 1]].
	].
	Transcript show: String cr, self asString, String cr, String cr.
	self signalStateChange.
	! !

!S2List methodsFor: 'accessing' stamp: 'db 6/21/2013 04:04:27.484'!
isSorted

	^ isSorted.! !

!S2List methodsFor: 'accessing' stamp: 'AT 7/1/2013 14:24:48.858'!
isSorted: anObject

	isSorted := anObject.
	"self isSorted ifTrue: self signalStateChange."
	"This should only be done in update function"! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.305'!
leftBoundIndex

	^ leftBoundIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.319'!
leftBoundIndex: anObject

	leftBoundIndex := anObject! !

!S2List methodsFor: 'updating-multilist' stamp: 'db 6/27/2013 20:33:57.362'!
mergeBackTmpList
|first last|
	Transcript show:'merging tmpList ',self tmpList asString ,' back into elements',String cr.
	first := self elements indexOf: nil ifAbsent: nil.
	last := self elements lastIndexOf: nil ifAbsent: nil.
	self tmpList do: [:ea | | nilIdx |
		nilIdx := self elements indexOf: nil ifAbsent: nil.
		nilIdx isNil ifTrue: [self elements add: ea] ifFalse: [self elements at: nilIdx put: ea]].
	self tmpList: #() asOrderedCollection.
	(self partitionIndices) do: [:ea |
		(ea isEmpty) ifTrue: [(self partitionIndices) at: (self partitionIndices indexOf: ea) put: nil]].
	(self partitionIndices) at: (self partitionIndices indexOf: nil) put: (first to: last) asOrderedCollection.
	[self partitionIndices includes: nil] whileTrue: [self partitionIndices remove: nil].
	Transcript show: self asString, String cr.
	self signalStateChange.! !

!S2List methodsFor: 'signals' stamp: 'db 6/26/2013 02:11:04.41'!
nextState: aS2List
	self emit.
	! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/25/2013 10:52:28.518'!
partitionIndices
"Since elements can be organized in sublists, I return these sublists with the indices of elements they contain."
"These indices should always be constantly increasing"
	^ partitionIndices! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/24/2013 11:51:47.863'!
partitionIndices: anObject

	partitionIndices := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/25/2013 10:51:30.762'!
partitions
"List elements can be contained in sublists. I return the actual elements ordered in sublists."
	(self partitionIndices) ifNil: [^nil].
	^((self partitionIndices) collect: [:pa |
		(pa collect: [:idx |
			(self elements) at: idx]) asOrderedCollection]) asOrderedCollection.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 10:12:41.195'!
pivotElement
	(self pivotIndex isNil or: [self pivotIndex > self elements size]) ifTrue: [^nil].
	^ self elements at: self pivotIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.804'!
pivotIndex

	^ pivotIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.817'!
pivotIndex: anObject

	pivotIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.331'!
rightBoundIndex

	^ rightBoundIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.345'!
rightBoundIndex: anObject

	rightBoundIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 10:14:28.961'!
secondFocusedElement
	(self secondFocusedIndex isNil or: [self secondFocusedIndex > self elements size]) ifTrue: [^nil].
	^ self elements at: self secondFocusedIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.775'!
secondFocusedIndex

	^ secondFocusedIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.79'!
secondFocusedIndex: anObject

	secondFocusedIndex := anObject! !

!S2List methodsFor: 'initialization' stamp: 'AT 7/1/2013 13:00:56.213'!
setupList: anObject
	self elements: anObject asOrderedCollection.
	self signalStateChange.! !

!S2List methodsFor: 'initialization' stamp: 'AT 6/27/2013 17:48:34.07'!
setupMultiListInterface
	self partitionIndices: #() asOrderedCollection.
	self partitionIndices add: (1 to: self elements size) asOrderedCollection.
	self activePartitions: #() asOrderedCollection.
	self tmpList: #() asOrderedCollection.! !

!S2List methodsFor: 'signalling' stamp: 'AT 7/1/2013 15:47:59.977'!
signalStateChange
	self nextState: (self deepCopy).! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/25/2013 10:50:22.759'!
sortedIndices

	^ sortedIndices! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:09.248'!
sortedIndices: anObject

	sortedIndices := anObject! !

!S2List methodsFor: 'updating' stamp: 'AT 6/27/2013 17:48:58.693'!
splitAfter: idx
|toSplit left right|
	Transcript show:'SplitAfter: ',idx asString, String cr.
	self partitionIndices ifNil: [self setupMultiListInterface].
	toSplit := self partitionIndices select: [:ea | (ea includes: idx)].
	toSplit ifNotNil: [
		toSplit := toSplit first.
		(idx = (toSplit last)) ifFalse:[
			left := toSplit copyFrom: 1 to: (toSplit indexOf: idx).
			right := toSplit copyFrom: ((toSplit indexOf: idx) + 1) to: (toSplit size).
			self partitionIndices add: left after: toSplit.
			self partitionIndices add: right after: left.
			self partitionIndices remove: toSplit.]].
	self signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/26/2013 01:20:35.482'!
splitAll
	Transcript show:'Splitting all', String cr.
	(1 to: self elements size - 1) do: [:ea | 
		self splitAfter: ea].
	self signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'AT 7/1/2013 15:47:45.665'!
swapFocusedElements
	Transcript show:'Switching element at ',self firstFocusedIndex asString, ' with ', self secondFocusedIndex asString, String cr.
	self switchElementAt: (self firstFocusedIndex) withElementAt: (self secondFocusedIndex);
		signalStateChange.
	Transcript show: self elements asString, String cr.! !

!S2List methodsFor: 'private' stamp: 'AT 7/1/2013 15:47:38.818'!
switchElementAt: i withElementAt: j
	|temp|
	temp := self elements at: i.
	self elements at: i put: (self elements at: j).
	self elements at: j put: temp.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/25/2013 10:50:13.412'!
tmpList
"For out-of-place implementations, this OrderedCollection contains"
"the actual elements that are being sorted in a new list."
	^ tmpList! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/25/2013 10:44:10.895'!
tmpList: anObject

	tmpList := anObject! !

!S2List methodsFor: 'updating-multilist' stamp: 'db 6/27/2013 20:34:03.972'!
updateActivePartitions: anOrderedCollection
	self activePartitions: anOrderedCollection.
	self signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:41:40.492'!
updateFirstFocusedIndex: idx
	Transcript show:'First focus: ',idx asString, String cr.
	self firstFocusedIndex: idx;
		signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/26/2013 01:21:23.576'!
updateLeftBoundaryIndex: idx
	Transcript show:'Left bound: ',idx asString, String cr.
	self leftBoundIndex: idx;
		signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:41:26.68'!
updatePivotIndex: idx
	Transcript show:'Pivot: ',idx asString, String cr.
	self pivotIndex: idx;
		signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/26/2013 01:21:37.698'!
updateRightBoundaryIndex: idx
	Transcript show:'Right bound: ',idx asString, String cr.
	self rightBoundIndex: idx;
		signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/26/2013 01:21:45.152'!
updateSecondFocusedIndex: idx
	Transcript show:'Second Focus: ',idx asString, String cr.
	self secondFocusedIndex: idx;
		signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:58:08.316'!
updateSorted: aBoolean
	self isSorted: aBoolean;
		signalStateChange.! !
